/**
 * Header file for project struct logic.
 */


// System Import Headers.
#include <ctype.h>
#include <mpi.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>


// Global Variables.
extern const int tag_main_termination;
extern const int tag_work_request;
extern const int tag_status_update;
extern const int tag_work_response;
extern const int tag_grr_query;


/**
 * Data for a single thread runtime.
 */
typedef struct {

    // "Global" thread values.
    int total_processors;
    int seconds_per_load;
    int total_loads;

    // "Local" thread values.
    int thread_num;
    int remaining_loads;
    char* log_file_location;
    FILE* log_file;
    // MPI_File* log_file;


} thread_struct;


// Function Prototypes.
thread_struct* initialize_thread_struct();
void free_thread_struct();
void _log();

#define log(message) _log(__FILE__, __LINE__, (message))
